/**************************************************************************************
* CFMove - a program that moves/copies files inside of the CF card
* of a TRGpro
* Copyright (C) 2001 by Enno Welbers
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or 
* (at your opinion) any later version.
* 
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the 
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with the program, see LICENSE.txt; if not, write to the Free
* Software Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  0211-1307  USA
*
* You can contact the author via: mkernel@users.sourceforge.net or enno_welbers@gmx.de
**************************************************************************************/
#include "cfmove.h"

char *acttitle="";
MemHandle acttitleHandle;

void title(char *Title)
{
  coordinates point;
  int count;
  drawpoly(&client,1);
  point.x=20;point.y=84;
  drawtext(&client,1,point,false,0,"Navigation Com");
  point.x=20;point.y=2;
  if(StrCompare(acttitle,"")==0)
    {
      acttitleHandle=MemHandleNew(StrLen(Title)+1);
      acttitle=MemHandleLock(acttitleHandle);
      for(count=0;count<StrLen(Title)+1;count++)
        acttitle[count]=Title[count];
      drawtext(&client,1,point,false,0,Title);
    }
  else
    {
      removetext(&client,point,false,acttitle);
      MemHandleUnlock(acttitleHandle);
      acttitleHandle=MemHandleNew(StrLen(Title)+1);
      acttitle=MemHandleLock(acttitleHandle);
      for(count=0;count<StrLen(Title)+1;count++)
        acttitle[count]=Title[count];
      drawtext(&client,1,point,false,0,Title);
    }
}

int UIDirContent(void)
{
  int listing=0,count,listingold;
  coordinates point;
  event Event;
  int retval=-3;
  drawpoly(&client,2);
  if(state==DEST)
    {
      point.x=42;
      point.y=119;
      drawtext(&client,1,point,false,0,"1");
      point.y=142;
      drawtext(&client,1,point,false,0,"2");
      point.x=80;
      point.y=113;
      drawtext(&client,1,point,false,0,"1: OK");
      point.y=123;
      drawtext(&client,1,point,false,0,"2: MKDIR");
    }
  point.x=22;
  while(1==1)
    {
      point.y=11;
      for(count=listing;count<listing+6;count++)
        {
          if(count<=dircontentmax)
            {
              point.y=point.y+10;
              drawtext(&client,1,point,false,0,DirContent[count].name);
            }
        }
      listingold=listing;
      while(1==1)
        {
          Event.type=-1;
          getevent(&client,&Event);
          if(Event.type==EventAppStopEvent)
            return -2;
          if(Event.type==EventKeyPressEvent)
            {
              if(Event.ekey.keycode==KeyPgUp)
                {
                  playsnd2();
                  if(listing-6>=0)
                    listing=listing-6;
                  else 
                    listing=0;
                  break;
                }
              else if(Event.ekey.keycode==KeyPgDown)
                {
                  playsnd2();
                  if(listing+12<=dircontentmax)
                    listing=listing+6;
                  else
                    listing=dircontentmax-5;
                  break;
                }
            }
          if(Event.type==EventMouseButtonPressEvent)
            {
              if(Event.ebtn.y>21 && Event.ebtn.y<31)
                {
                  if(state!=DEST || DirContent[listing].isdir==true)
                    {
                      playsnd();
                      retval=listing;
                      break;
                    }
                }
              else if(Event.ebtn.y>31 && Event.ebtn.y<41)
                {
                  if(state!=DEST || DirContent[listing+1].isdir==true)
                    {
                      playsnd();
                      retval=listing+1;
                      break;
                    }
                }
              else if(Event.ebtn.y>41 && Event.ebtn.y<51)
                {
                  if(state!=DEST || DirContent[listing+2].isdir==true)
                    {
                      playsnd();
                      retval=listing+2;
                      break;
                    }
                }
              else if(Event.ebtn.y>51 && Event.ebtn.y<61)
                {
                  if(state!=DEST || DirContent[listing+3].isdir==true)
                    {
                      playsnd();
                      retval=listing+3;
                      break;
                    }
                }
              else if(Event.ebtn.y>61 && Event.ebtn.y<71)
                {
                  if(state!=DEST || DirContent[listing+4].isdir==true)
                    {
                      playsnd();
                      retval=listing+4;
                      break;
                    }
                }
              else if(Event.ebtn.y>71 && Event.ebtn.y<81)
                {
                  if(state!=DEST || DirContent[listing+5].isdir==true)
                    {
                      playsnd();
                      retval=listing+5;
                      break;
                    }
                }
              else if(Event.ebtn.y>81 && Event.ebtn.y<91)
                {
                  if(state!=DEST || DirContent[listing+6].isdir==true)
                    {
                      playsnd();
                      retval=listing+6;
                      break;
                    }
                }
              else if(Event.ebtn.y>113 && Event.ebtn.y<130 && Event.ebtn.x>30 && Event.ebtn.x<40 && listing>0)
                {
                  playsnd2();
                  listing--;
                  break;
                }
              else if(Event.ebtn.y>140 && Event.ebtn.y<158 && Event.ebtn.x>30 && Event.ebtn.x<40 && listing+6<=dircontentmax)
                {
                  playsnd2();
                  listing++;
                  break;
                }
              else if(Event.ebtn.y>130 && Event.ebtn.y<140 && Event.ebtn.x>12 && Event.ebtn.x<30)
                {
                  playsnd2();
                  if(listing-6>=0)
                    listing=listing-6;
                  else 
                    listing=0;
                  break;
                }
              else if(Event.ebtn.y>130 && Event.ebtn.y<140 && Event.ebtn.x>40 && Event.ebtn.x<58)
                {
                  playsnd2();
                  if(listing+12<=dircontentmax)
                    listing=listing+6;
                  else
                    listing=dircontentmax-5;
                  break;
                }
              else if(Event.ebtn.y>113 && Event.ebtn.y<130 && Event.ebtn.x>40 && Event.ebtn.x<58 && state==DEST)
                {
                  playsnd();
                  retval=dircontentmax+1;
                  break;
                }
              else if(Event.ebtn.y>140 && Event.ebtn.y<158 && Event.ebtn.x>40 && Event.ebtn.x<58 && state==DEST)
                {
                  playsnd2();
                  retval=-4;
                  break;
                }
            }
        }
      point.y=11;
      for(count=listingold;count<listingold+6;count++)
        {
          if(count<=dircontentmax)
            {
              point.y=point.y+10;
              removetext(&client,point,false,DirContent[count].name);
            }
        }
      if(retval==-4)
        {
          if(newdir()==0)
            retval=0;
          else retval=-3;
          point.x=80;
          point.y=123;
          removetext(&client,point,false,"2: CANCEL");
          drawtext(&client,1,point,false,0,"2: MKDIR");
          title("DEST? (Use OK (Circle))");
          point.x=22;
        }
      if(retval!=-3)
        {
          if(state==DEST)
            {
              point.x=42;
              point.y=119;
              removetext(&client,point,false,"1");
              point.y=142;
              removetext(&client,point,false,"2");
              point.x=80;
              point.y=113;
              removetext(&client,point,false,"1: OK");
              point.y=123;
              removetext(&client,point,false,"2: MKDIR");
            }
          return retval;
        }
    }
}

int MvCpCa(void)
{
  coordinates point;
  event Event;

  title("What to do with src and dest?");
  point.x=30;point.y=30;
  drawtext(&client,1,point,false,0,src);
  point.y=60;
  drawtext(&client,1,point,false,0,dest);
  point.x=42;point.y=119;
  drawtext(&client,1,point,false,0,"1");
  point.y=142;
  drawtext(&client,1,point,false,0,"2");
  point.x=22;
  drawtext(&client,1,point,false,0,"3");
  point.x=80;
  point.y=113;
  drawtext(&client,1,point,false,0,"1: MOVE");
  point.y=123;
  drawtext(&client,1,point,false,0,"2: COPY");
  point.y=133;
  drawtext(&client,1,point,false,0,"3: CANCEL");
  client.runsyshandleevent=true;
  while(1==1)
    {
      getevent(&client,&Event);
      if(Event.type==EventAppStopEvent)
      {
        playsnd();
        point.x=point.y=30;
        removetext(&client,point,false,src);
        point.y=60;
        removetext(&client,point,false,dest);
        return 0;
      }
      if(Event.type==EventMouseButtonPressEvent && Event.ebtn.y>113 && Event.ebtn.y<130 && Event.ebtn.x>40 && Event.ebtn.x<58)
      {
        playsnd();
        point.x=point.y=30;
        removetext(&client,point,false,src);
        point.y=60;
        removetext(&client,point,false,dest);
        return 2;
      }
      if(Event.type==EventMouseButtonPressEvent && Event.ebtn.y>140 && Event.ebtn.y<158 && Event.ebtn.x>40 && Event.ebtn.x<58)
      {
        playsnd();
        point.x=point.y=30;
        removetext(&client,point,false,src);
        point.y=60;
        removetext(&client,point,false,dest);
        return 1;
      }
      if(Event.type==EventMouseButtonPressEvent && Event.ebtn.y>140 && Event.ebtn.y<158 && Event.ebtn.x>12 && Event.ebtn.x<30)
      {
        playsnd();
        point.x=point.y=30;
        removetext(&client,point,false,src);
        point.y=60;
        removetext(&client,point,false,dest);
        return 0;
      }
    }
}
